<script lang="ts">
	import {
		ChevronDownIcon,
		ChevronUpIcon,
		CornerDownRightIcon,
		Edit2Icon,
		Trash2Icon
	} from 'svelte-feather-icons';
	import type { Category, ProductFB } from '../type';
	import { slide } from 'svelte/transition';
	import {
		addDoc,
		collection,
		deleteDoc,
		doc,
		getDocs,
		query,
		setDoc,
		where
	} from 'firebase/firestore';
	import { db, storage } from '$lib/firebase/firebase';
	import Button from '../../../../../components/Button.svelte';
	import AddProduit from './AddProduit.svelte';
	import { createEventDispatcher, onMount } from 'svelte';
	import { deleteObject, getDownloadURL, ref, uploadBytes } from 'firebase/storage';
	import AddCategory from './AddCategory.svelte';
	import EditProduct from './EditProduct.svelte';
	import ProductDetail from './ProductDetail.svelte';

	export let category: Category;
	export let index: number;

	let openCategory = false;

	let products: ProductFB[] = [];
	const getProducts = async () => {
		products = [];
		const q = query(collection(db, 'products'), where('categoryId', '==', category.id));
		const querySnapshot = await getDocs(q);
		querySnapshot.forEach((doc) => {
			products.push({ ...doc.data(), id: doc.id } as ProductFB);
		});
		products = products;
	};

	const uploadFileToStorage = async (file: File): Promise<string> => {
		let downloadURL = '';
		const storageRef = ref(storage, 'products/' + file.name);
		try {
			const snapshot = await uploadBytes(storageRef, file);
			downloadURL = await getDownloadURL(snapshot.ref);
		} catch (error) {
			return '';
		}
		return downloadURL;
	};

	const addProducts = async (e: any) => {
		// Fetching the file
		const selectedFile: File = e.detail.newProduct.image;
		const downloadURL = await uploadFileToStorage(selectedFile);

		// If the upload is successfull
		if (downloadURL !== '') {
			const productRequest = {
				name: e.detail.newProduct.name,
				categoryId: e.detail.newProduct.categoryId,
				imgUrl: downloadURL,
				imgName: selectedFile.name
			};
			const docRef = collection(db, 'products');
			await addDoc(docRef, productRequest).catch(() => {
				// If there is an error, we delete the file from the storage
				deleteObject(ref(storage, 'products/' + selectedFile.name));
			});
			await getProducts();
			showAddProduit = false;
		}
	};

	const editProduct = async (e: any) => {
		const docRef = doc(db, 'products', e.detail.newProduct.id);
		await setDoc(docRef, e.detail.newProduct, { merge: true });
		await getProducts();
		showEditProduit = false;
	};

	const deleteCategory = async () => {
		if (products) {
			products.forEach(async (product) => {
				await deleteDoc(doc(db, 'products', product.id));
				await deleteObject(ref(storage, 'products/' + product.imgName));
			});
			await deleteDoc(doc(db, 'categories', category.id));
		}
		dispatch('deleteCategory');
	};
	const dispatch = createEventDispatcher();

	onMount(() => {
		getProducts();
	});

	let showAddProduit = false;

	let showEditProduit = false;
	let showEditCategory = false;

	let editProductRequest: ProductFB = {
		id: '',
		name: '',
		categoryId: '',
		imgUrl: '',
		imgName: ''
	};
</script>

<div class={`flex flex-col gap-4 p-4 rounded-lg ${index % 2 ? 'bg-noir-500' : 'bg-noir-600'}`}>
	<div
		class="flex gap-2 items-center justify-between"
		on:click={() => {
			openCategory = !openCategory;
			showAddProduit = false;
		}}
		on:keydown
	>
		<div class="flex gap-2 items-center p-2">
			<div on:click|stopPropagation on:keydown>
				<Button type="error" on:dblclick={deleteCategory}>
					<Trash2Icon />
				</Button>
				<Button
					type="secondary"
					on:click={() => {
						showEditCategory = true;
					}}
				>
					<Edit2Icon />
				</Button>
			</div>
			<div class="flex flex-col">
				<span class="text-lg font-semibold"> {category.name}</span>
				<div class="flex gap-2 items-center">
					<span class="text-primary-500"><CornerDownRightIcon /></span>
					<span>{@html category.description || 'Aucune'}</span>
				</div>
			</div>
		</div>

		{#if openCategory}
			<ChevronUpIcon />
		{:else}
			<ChevronDownIcon />
		{/if}
	</div>
	{#if openCategory}
		<div class="flex flex-col gap-2 justify-center p-4" transition:slide>
			<div class="border-b border-primary-700" />
			{#each products as product, i}
				<ProductDetail {product} {category} on:refresh={getProducts} on:add={editProduct} />
			{:else}
				Aucun produit
			{/each}
			{#if !showAddProduit}
				<div class="flex w-full justify-end" transition:slide>
					<Button type="secondary" on:click={() => (showAddProduit = true)}>
						Ajouter un produit
					</Button>
				</div>
			{/if}
			<AddProduit bind:show={showAddProduit} on:add={addProducts} categoryId={category.id} />
		</div>
	{/if}
</div>
<AddCategory
	bind:show={showEditCategory}
	on:add
	categoryId={category.id}
	newCat={{
		name: category.name,
		description: category.description
	}}
/>
